Subject: Re: Question about TPA/HDS feature of bnxt_en

From: Jakub Kicinski <[email-masked]>
Date: Tue, 13 Aug 2024 18:17:08 -0700

On Tue, 13 Aug 2024 19:42:51 +0900 Taehee Yoo wrote:
> Hi,
> I'm currently testing the device memory TCP feature with the bnxt_en
> driver because Broadcom NICs support TPA/HDS, which is a mandatory
> feature for the devmem TCP.
> But it doesn't work for short-sized packets(under 300?)
> So, the devmem TCP stops or errors out if it receives non-header-splitted skb.
> 
> I hope the bnxt_en driver or firmware has options that force TPA to
> work for short-sized packets.
> So, Can I get any condition information on TPA?

I don't have any non-public info but look around the driver for
rx_copy_thresh, it seems to be sent to FW. I wonder if setting
it to 1 or 0 would work. Especially this:

static int bnxt_hwrm_vnic_set_hds(struct bnxt *bp, struct bnxt_vnic_info *vnic)
...
		req->hds_threshold = cpu_to_le16(bp->rx_copy_thresh);